// *********************************************************************************************
//   Java application to add "resolution" property to a given list of binding site structures
//   
//                    developed by Hui Sun Lee (huisun.cadd@gmail.com)
// *********************************************************************************************

import java.io.*;
import java.util.Hashtable;



public class AddPropertyResolution{
	public static void main( String[] args ){
		if( args.length == 0 || args.length != 3 || args[0].equalsIgnoreCase( "--help" ) ){
			System.out.println( "Usage: AddPropertyResolution" );
			System.out.println( "             -opts [list of structures]" );
			System.out.println( "                   [directory where original PDB files are saved (.../)]" );
			System.out.println( "                   [output file name]" );

			return;
		}
		
		
		
		String mList = args[0];
		String mDirPDB = args[1];
		String mOutFile = args[2];
		
		
		
		FileInputStream list_input;
		BufferedReader list_reader;
		String list_line;

		FileInputStream struct_input;
		BufferedReader struct_reader;
		String struct_line;

		DataOutputStream out = null;	
		
			
		String resolution = null;
		String [] array;

			

		try{   
			out = new DataOutputStream( new FileOutputStream( new File( mOutFile ) ) );
			
			
			list_input = new FileInputStream( new File( mList ) );
			list_reader = new BufferedReader( new InputStreamReader( list_input ) );
			
			while( ( list_line = list_reader.readLine() ) != null ){
				struct_input = new FileInputStream( new File( mDirPDB + list_line.substring( 0, 4 ) + ".pdb" ) );
				struct_reader = new BufferedReader( new InputStreamReader( struct_input ) );
				
				while( ( struct_line = struct_reader.readLine() ) != null ){
					if( struct_line.startsWith( "REMARK   2 RESOLUTION" ) ){
						array = struct_line.substring( 22, 30 ).trim().split( " " );
						resolution = array[0];
						
						if( resolution.equalsIgnoreCase( "NOT" ) )
							resolution = "1.00";
											
						break;
					}
				}

				struct_input.close();
				struct_reader.close();
				
				System.out.println( list_line + "\t" + list_line.substring( 0, 4 ) + ".pdb" + "\t" + resolution );
				out.writeBytes( list_line + "\t" + resolution + "\n" );				
			}
			
			list_input.close();
			list_reader.close();
			
			
			out.close();
		}
		catch( Exception exception ){
			exception.printStackTrace();
		}
	}
}
