// *************************************************************
//        Java application to check G-LoSA search results
//
//        eveloped by Hui Sun Lee (huisun.cadd@gmail.com)
// *************************************************************

import java.io.*;


public class CheckGLoSASearchResults{
	public static void main( String[] args ) throws IOException{
		if( args.length == 0 || args.length != 4 || args[0].equalsIgnoreCase( "--help" ) ){
			System.out.println( "Usage:   CheckGLoSASearchResults" );
			System.out.println( "         		-opts [directory where the sublists of library structures are saved]" );
			System.out.println( "         		      [index of start sublist (from 1)]" );
			System.out.println( "          		      [index of last  sublist (from 1)]" );
			System.out.println( "          		      [directory where G-LoSA search results are saved]" );

			return;
		}	
		
		String mDirList = args[0];
        int mIndexStartSublist = Integer.parseInt( args[1] );
        int mIndexLastSublist = Integer.parseInt( args[2] );
        String mDirTarget = args[3];
        
        		

		FileInputStream list_stream;
		BufferedReader list_reader;	
		String list_line;

		String[] array;

        
        
        
		try{		
			int total_num_structures = 0;
			int total_num_data = 0;
			
			for( int i = mIndexStartSublist ; i <= mIndexLastSublist ; i++ ){
				total_num_structures = 0;
				
				list_stream = new FileInputStream( new File( mDirList + "list_" + i + ".txt" ) );
				list_reader = new BufferedReader( new InputStreamReader( list_stream ) );
			
				while( ( list_line = list_reader.readLine()) != null ){
					total_num_structures++;
				}				
				
				list_reader.close();
				list_stream.close();	
				
				
				
				total_num_data = 0;
				
				list_stream = new FileInputStream( new File( mDirTarget + "search_result_" + i + "/score.txt" ) );
				list_reader = new BufferedReader( new InputStreamReader( list_stream ) );
			
				while( ( list_line = list_reader.readLine()) != null ){
					total_num_data++;
				}				
				
				list_reader.close();
				list_stream.close();	
				

				
				if( total_num_structures != total_num_data )
					System.out.println( "Error in job: " + "search_result_" + i );
			}
		}
		catch( Exception exception ){
			exception.printStackTrace();
		}
	}		
}
	