// *****************************************************************************************************
//      Java application to merge G-LoSA search results from multiple jobs into a single result file
//
//                            developed by Hui Sun Lee (huisun.cadd@gmail.com)
// *****************************************************************************************************

import java.io.*;


public class MergeGLoSASearchResults{
	public static void main( String[] args ) throws IOException{
		if( args.length == 0 || args.length != 3 || args[0].equalsIgnoreCase( "--help" ) ){
			System.out.println( "MergeGLoSASearchResults" );
			System.out.println( "           -opts [directory where G-LoSA search results are saved]" );
            System.out.println( "                 [index of start sublist (from 1)]" );
			System.out.println( "                 [index of last  sublist (from 1)]" );
           
			return;
		}
		
		
		String mDirResults = args[0];
        int mIndexStartSublist = Integer.parseInt( args[1] );
        int mIndexLastSublist = Integer.parseInt( args[2] );

        		
		
		FileInputStream result_stream;
		BufferedReader result_reader;	
		String result_line;
		
		DataOutputStream score_out;	
		DataOutputStream matrix_out;	
		
		Runtime rt = Runtime.getRuntime();
		Process pr;
		LineNumberReader output_log;
		String pr_line;
		String command;
		
		String mListFile = args[0];
		String mDir = args[1];	

		String [] array;

		
		

		try{
			score_out = new DataOutputStream( new FileOutputStream( new File( mDirResults + "score.txt" ) ) );
			matrix_out = new DataOutputStream( new FileOutputStream( new File( mDirResults + "list_matrix.txt" ) ) );
			
			
			for( int i = mIndexStartSublist ; i <= mIndexLastSublist ; i++ ){
				result_stream = new FileInputStream( new File( mDirResults + "search_result_" + i + "/score.txt" ) );
				result_reader = new BufferedReader( new InputStreamReader( result_stream ) );	

				while( ( result_line = result_reader.readLine()) != null ){
					score_out.writeBytes( result_line + "\n" );
				}

				result_reader.close();
				result_stream.close();
				
				
				result_stream = new FileInputStream( new File( mDirResults + "search_result_" + i + "/list_matrix.txt" ) );
				result_reader = new BufferedReader( new InputStreamReader( result_stream ) );	

				while( ( result_line = result_reader.readLine()) != null ){
					matrix_out.writeBytes( result_line + "\n" );
				}

				result_reader.close();
				result_stream.close();
				
				
				System.out.println( "The results from search_result_" + i + " has been merged into score.txt and list_matrix.txt" );
			}	
			
			
			matrix_out.close();
			score_out.close();	
		}
		catch( Exception exception ){
			exception.printStackTrace();
		}		
	}	
}
