// ****************************************************
//                  Class Molecule
//   
//   developed by Hui Sun Lee (huisun.cadd@gmail.com)
// *****************************************************

import java.util.Hashtable;
import java.util.Vector;



public class Molecule{
	Vector<Atom> atoms = null;
	Hashtable<String,String> htResIndex = null;
	boolean [] isSelectedResidue;


	public Molecule(){
		atoms = new Vector<Atom>();
		htResIndex = new Hashtable<String,String>();
		isSelectedResidue = new boolean[3000];
	}
	
	
    public void setResIndex(){
    	int num_atoms = atoms.size();
    	String value = null;
    	int index = -1;
    	
    	for( int i = 0 ; i < num_atoms ; i++ ){
    		value = htResIndex.get( atoms.elementAt(i).sequence_number_nr );
    		
    		if( value == null ){
    			index++;
    			htResIndex.put( atoms.elementAt(i).sequence_number_nr, "" + index );
    		}
    	}
    }	
    
    
    public void resetBooleanArray(){
    	for( int i = 0 ; i < isSelectedResidue.length ; i++ )
			isSelectedResidue[i] = false; 
    }
    
    
    public int getNumSelectedResidue(){
		int num = 0;
		
		for( int i = 0 ; i < isSelectedResidue.length ; i++ ){
			if( isSelectedResidue[i] ) 
				num++;
		}
		
		return num;
	}
}