// ******************************************************************************************
//        Java application to split structure list into user-defined number of sublists
//
//                    developed by Hui Sun Lee (huisun.cadd@gmail.com)
// ******************************************************************************************

import java.io.*;


public class SplitList{
	public static void main( String[] args ) throws IOException{
		if( args.length == 0 || args.length != 3 || args[0].equalsIgnoreCase( "--help" ) ){
			System.out.println( "Usage:   SplitList" );
			System.out.println( "             opt [original list]" );
			System.out.println( "                 [number of subsets]" );
			System.out.println( "                 [target directory]" );

			return;
		}			

		FileInputStream list_stream;
		BufferedReader list_reader;	
		String list_line;

		DataOutputStream out = null;	

		String[] array;

        String mList = args[0];
        int mNumSubset = Integer.parseInt( args[1] );
        String mDirTarget = args[2];
        
        
        
        
		try{		
			// *** read full list ***
			int total_num_elements = 0;
			int [] aNumElement = new int[mNumSubset];
			
			
			list_stream = new FileInputStream( new File( mList ) );
			list_reader = new BufferedReader( new InputStreamReader( list_stream ) );
			
			while( ( list_line = list_reader.readLine()) != null ){
				total_num_elements++;
			}				
				
			list_reader.close();
			list_stream.close();	
			
			System.out.println( "Total number of structures: " + total_num_elements + "\n" );
			
			
			
			
			int num_elements_each_subset = total_num_elements / mNumSubset;
			int left_over = total_num_elements - num_elements_each_subset * mNumSubset;
			
			for( int i = 0 ; i < mNumSubset ; i++ ){
				aNumElement[i] = num_elements_each_subset;
				
				if( i < left_over )
					aNumElement[i]++;
			}
			
			
			
			// split full list into a given number of sublists ***
			list_stream = new FileInputStream( new File( mList ) );
			list_reader = new BufferedReader( new InputStreamReader( list_stream ) );
			
			for( int i = 0 ; i < mNumSubset ; i++ ){
				System.out.println( "Sublist " + (i+1) + " (list_" + (i+1) + ".txt): " + aNumElement[i] + " structures" );
				
				out = new DataOutputStream( new FileOutputStream( new File( mDirTarget + "list_" + (i+1) + ".txt" ) ) );
				
				for( int j = 0 ; j < aNumElement[i] ; j++ ){
					out.writeBytes( list_reader.readLine() + "\n" );
				}
			}
			
			list_reader.close();
			list_stream.close();	
		}
		catch( Exception exception ){
			exception.printStackTrace();
		}
	}		
}
	